import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
/**
 * Write a description of class MyWorld here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 * IMPROVEMENTS
 *-LEVELS
 *-SHOOTING UP KEY
 *
 */
public class MyWorld  extends World
{
    private static final int MAX_NUM_GUYS = 100;
    private int acted = 0;
    private int numCreated = 0;    
    private int numCaught = 0;
    private int numFallen = 0;
    Label label, endLabel, lifeLabel;
    public boolean gameOver = false;
    private int numLives = 3;
    House house;
    /**
     * Constructor for objects of class MyWorld.
     * 
     */
    public MyWorld()
    {    
        // Create a new world with 700x650 cells with a cell size of 1x1 pixels.
        super(700, 650, 1);
        prepare();
    }

    public void act() 
    {
        acted++;
        if (!gameOver) {
            randomGuys();
            randomClouds();
            randomRocks();
            checkGameOver();        
        }
    }
    
    public void randomClouds()
    {
        if ((acted % 32) == 0)
        {
            createCloud(false); //right cloud
            createCloud(true); //left cloud
        }
    }
    
    public void randomGuys()
    {
        if ((acted % 16) == 0 && numCreated < MAX_NUM_GUYS)
        {
            createGuy();
        }
    }
    
    public void randomRocks()
    {
        if ((acted % 28) == 0)
        {
            createRock();
        }
    }
    
    public void createCloud(boolean left)
    {
        int x;
        Actor cloud;
        if (left) {
            x = getWidth();
            cloud = new LeftCloud();
        } else {
            x = 0;
            cloud = new RightCloud();
        }
        int y = Greenfoot.getRandomNumber (getHeight());
        if (y >= getHeight() - 100)
            y = y - 100;
        addObject (cloud, x, y);
    }
    
    public void createGuy()
    {
        int x = Greenfoot.getRandomNumber (getWidth());
        int y = 20;
        addObject ( new Guy(), x, y);
        numCreated++;
    }
    
    public void createRock()
    {
        int x = Greenfoot.getRandomNumber (getWidth());
        int y = 20;
        addObject ( new Rock(), x, y);
    }

    public void incCaughtScore()
    {
        numCaught ++;
        label.setText("Score: "+ numCaught + "/" + MAX_NUM_GUYS);
    }
    
    public void decHouseLife()
    {
        numLives--;
        lifeLabel.setText("Lives:"+ numLives);
    }
       
    public void incFallenScore()
    {
        numFallen ++;
    }

    public boolean checkGameOver()
    {
        if (numFallen+numCaught == MAX_NUM_GUYS)
        {
            endLabel.setText("GAME OVER");
            gameOver = true;
        }
        if (numLives == 0)
        {
            endLabel.setText("GAME OVER");
            gameOver = true;
            removeObject(house);
        }
        return gameOver;
    }

    /**
     * Prepare the world for the start of the program. That is: create the initial
     * objects and add them to the world.
     */
    private void prepare()
    {
        label = new Label("Score: 0/" + MAX_NUM_GUYS, Color.red, Color.yellow, 25);
        addObject (label,60, 50);

        endLabel = new Label("", Color.white, Color.cyan, 50);
        addObject (endLabel,350, 300);

        lifeLabel = new Label("Lives:" + numLives, Color.red, Color.yellow, 25);
        addObject (lifeLabel,660, 50);

        house = new House();
        addObject (house, getWidth()/2, getHeight()-20);
    }
}