import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
    
/** 
 * Write a description of class Rock here.
 *  
 * @author (your name) 
 * @version (a version number or a date)
 */ 
public class Rock  extends Actor
{  
    private double acceleration = 0.25;
    private double vSpeed = 0;
    private static final int NUM_FRAGMENTS = 10;
    /**
     * Act - do whatever the Rock wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        checkFall();
    }
    
    public void checkFall()
    {
        if(onHouse()) {
            ((MyWorld)getWorld()).decHouseLife();
            explode();
        }
        else if(onBullet()) {
            explode();
            
        }
        else{
            if (outOfWorld()) {
                getWorld().removeObject(this);
            }
            else{
                fall();
            }
        }
    }
    
    public void explode()
    {
        GreenfootSound sound=new GreenfootSound("Grenade.wav");
        sound.play(); 
        placeDebris (getX(), getY(), NUM_FRAGMENTS);
        getWorld().removeObject(this);
    }
    
    private void placeDebris(int x, int y, int numFragments)
    {
        for (int i=0; i < numFragments; i++) {
            getWorld().addObject (new Debris(), x, y);
        }
    }   
    
    public void fall()
    {
        setLocation ( getX(), (int)(getY() + vSpeed));
        vSpeed = vSpeed + acceleration;
    }
    
    public boolean onHouse()
    {
        Actor under = getOneIntersectingObject(House.class);
        return under != null;
    }
    
    public boolean onBullet()
    {
        Actor bullet = getOneIntersectingObject(Bullet.class);
        if(bullet != null){
            getWorld().removeObject(bullet);
        }
        return bullet != null;
    }
    
    private boolean outOfWorld()
    {
        return  (getY() >= getWorld().getHeight()-15);
    }
}   